#INCLUDE <hmg.ch>
FUNCTION GIMPRG()

set navigation 			extended
set tooltipbackcolor	{255,255,220 }
set tooltipforecolor 	{000,000,000 }
set language to 		english
set codepage to 		spanish	
set escape 				on
set interactiveclose 	on
set multiple 			off
set exclusive 			on
set confirm				on
set deleted 			on
set decimals to 		2	
set fixed 				on	
set exact 				on
set softseek 			on	
set date 				italian	
set autoscroll off
set century 			on	

xGridFont 		= "'Courier New'"
xSysFontName 	= "'Arial'"
xFiltering05 	= .f.
xFilterSet05 	= "estado=estado"
xPuntero 		= 0
xPreMark 		= .t.
xDPGim 			= "5"
xesc 			= 1

select 7	
use LST_GRD.dbf alias LST_FLT

***********************************************************
* VARIABLE DINAMICAS PARA GRID
***********************************************************	// DEFINICIONES DE VARIABLES DINAMICAS PARA CONTROL GRID
	NorText := 	{ || This.CellValue }		

	EstText := 	{ || 	if ( estado = 0 , "" ,;
						if ( estado = 2 , "TERMINADO" ,;
						if ( estado = 1 , "PENDIENTE" ,;
						if ( estado = 3 , "PROCESO" , "VALIDADO" ))))}	

***********************************************************	
	EstColBack := { || 	if ( estado = 0 , { 255, 255, 255 } ,;
						if ( estado = 1 .and. prioridad < 2 , { 255, 64, 64 } ,;
						if ( estado = 1 .and. prioridad = 2 , { 255, 64, 64 } ,;
						if ( estado = 2 , { 100, 255, 100 } ,;
						if ( estado = 3 , { 255, 255, 100 } , { 64, 200, 64 } )))))}

***********************************************************	
	EstColFore := { || 	if ( estado = 0 , {   0,  0,  0 } ,;
						if ( estado = 1  .and. prioridad < 2 , { 255,255,255 } ,;
						if ( estado = 1  .and. prioridad = 2 , { 255,255,255 } ,;
						if ( estado = 2 , {   0,  0,  0 } ,;
						if ( estado = 3 , {   0,  0,  0 } , {   0,  0,  0 } )))))}	

***********************************************************	
	PrevColText := { || if ( prioridad = 1 , { 155,   0,   0 } ,;
						if ( prioridad = 2 , { 255,   0,   0 } ,;	
						if ( xPreMark , if ( origen = "9" , {   0,  0,255 } ,{   0,  0,  0 } ),{   0,  0,  0 })))}	

	NormColText := { || {   0,  0,  0 } }

***********************************************************
	MemoText	:= { || if ( .not.pic .and. empty(alltrim(memo)) .and. empty(alltrim(bill)) , " " ,;
						if ( .not.empty(alltrim(bill)) , "V" , "+"))  }	
	MemoColText := { || { 50, 50, 50 } }

	MemoColBack := { || if ( .not.empty(alltrim(NumPrev)).and.origen<>"9" ,{ 160,160,255 } ,;
						if ( Pic ,{ 160,160,160 } ,;
						if ( .not.empty(alltrim(memo)) , { 220,220,220 } ,{ 255,255,255 })))}
***********************************************************
	DatColBack := { || {220,220,220} }
***********************************************************	
	NorColBack := { || {255,255,255} }
***********************************************************



***********************************************************
*DEFINICIN CONSOLA
***********************************************************
define window console           							;
	at 1,1		       	            	;
	width 1035	        							;
	height 724		      						;
	on interactiveclose	exitgim()							;
	on init IniProcess()									;
	main
		
	define main menu of console	
		popup "Menu"																		name A0									
			item "Salir" action (exitgim()) name A19
		end popup
	end menu	

***********************************************************
	define checkbutton BookBt5								// Boton console 5 > Activar filtro de la columna 5 > Estado
		parent Console
		row 0*xesc
		col 530*xesc
		caption "Estado"
		width 76*xesc
		height 24*xesc
		fontsize 9*xesc
		fontname &xSysFontName
		value xFiltering05
		tooltip "Filtrar el estado seleccionado / Sin selecin = Pendiente + Proceso"
		onchange (FilterCol5())
	end	checkbutton
	
	define grid bookslv										// Definicion del control de lista de incidencias filtradas esclavo BOOKSLV	
		parent console	
		row 24*xesc
		col (0-5)
		width 1025*xesc							 
		height ((620)*xesc)						
		fontname &xGridFont
		fontsize 9*xesc
		visible .f.
		virtual .t.
		rowsource "LST_FLT"
		headers {"Departamento","Fecha","Hora","Ubicacin","Concepto","Estado","Fecha","Hora","Oficial","Observaciones",""}
		columnfields {"origen","afecha","ahora","ubicacion","concepto","estado","cfecha","chora","oficial","notas","NumPrev"}
		widths {0,68*xesc,50*xesc,120*xesc,294*xesc,75*xesc,68*xesc,50*xesc,80*xesc,178*xesc,18*xesc}
		dynamicbackcolor { DatColBack ,DatColBack , DatColBack , NorColBack , NorColBack , EstColBack , DatColBack , DatColBack , NorColBack , NorColBack, MemoColBack }
		dynamicforecolor { NormColText ,NormColText , NormColText , PrevColText , PrevColText , EstColFore , NormColText , NormColText , NormColText , NormColText, MemoColText }
		dynamicdisplay { NorText ,NorText , NorText , NorText , NorText , EstText , NorText , NorText , NorText , NorText, MemoText }
		cellnavigation .f.
		showheaders .f.
		buffered .t.
		lines .t.
		allowedit .f.
		justify { {"NILL"},{"NILL"},{"NILL"},{"NILL"},{"NILL"}, BROWSE_JTFY_CENTER, {"NILL"},{"NILL"},{"NILL"},{"NILL"}}
	end grid	
end window
activate window Console

***********************************************************
PROCEDURE INIPROCESS										// Proceso de inicio
***********************************************************

* Console.bookslv.PaintDoubleBuffer := .t.

select 5													// Abrir bases de datos de trabajo para su enlace con el control GRID
use LST_MST.dbf
go top
close 7
FilterBook()												// Ajusta filtrado y crea lista FLT en area 6
ShowBook()													// Prepara lista de incidencias para mostrar y ajusta puntero a la siguiente posicion libre
return

***********************************************************
PROCEDURE FILTERBOOK										
***********************************************************
if Console.bookslv.visible = .t.
	wait window "      " + "Preparando informacin" + "      " nowait
endif	

xFilterRules = ""
if xFiltering05		
	xFilterRules = xFilterRules+"&xFilterSet05" + ".and."
endif
xFilterRules = xFilterRules +  " Origen <> '0'" + ".and."				// Oculta lineas en blanco de incidencias recien borradas al filtrar
xFilterRules = xFilterRules + "DPGim=xDPGim"							// Filtro maestro departamental

close 6
select 5
erase "LST_FLT.dbf"
copy to LST_FLT.dbf for &xFilterRules
select 6
use LST_FLT.dbf
xPuntero=reccount()+1									// Actualizar puntero filtrado con la lista filtrada
close 5
append from LST_MST.dbf for empty(alltrim(origen))		// Copiar vacios pero numerados
select 5
use LST_MST.dbf
wait clear
return

***********************************************************
PROCEDURE SHOWBOOK											// Motrar o refrescar informacion el los Grid Book y BookSlv
***********************************************************
select 6
console.bookslv.visible := .f.
console.bookslv.refresh
console.bookslv.value := {xPuntero+3,4}			// Situar cursor del grid para dejar 4 lineas de espacio inferior
console.bookslv.value := {xPuntero-3,4}			// Situar cursor del grid para dejar 4 lineas de espacio inferior
console.bookslv.visible := .t.
console.bookslv.setfocus
return

***********************************************************
PROCEDURE EXITGIM											// Motrar o refrescar informacion el los Grid Book y BookSlv
***********************************************************
close all
quit

***********************************************************
PROCEDURE FILTERCOL5										// Filtrado de Estados por boton de filtrado en columna
***********************************************************
	if console.bookbt5.value 
		do case
		case estado=1										// Pendiente
			xFiltering05=.t.
			xFilterSet05="(estado=1)"
			console.bookbt5.value := .t.
	
		case estado=2										// Terminado
			xFiltering05=.t.
			xFilterSet05="(estado=2)"
			console.bookbt5.value := .t.
		
		case estado=3										// Proceso
			xFiltering05=.t.
			xFilterSet05="(estado=3)"
			console.bookbt5.value := .t.
	
		case estado=4										// Validado
			xFiltering05=.t.
			xFilterSet05="(estado=4)"
			console.bookbt5.value := .t.
		
		case estado=0										// Pendiente + Proceso
			xFiltering05=.t.
			xFilterSet05="(estado=1.or.estado=3)"
			console.bookbt5.value := .t.
		endcase
		if Console.bookslv.visible = .t.					// Al inicio solo es necesario configurar el filtro departamental
			filterbook()									// No realizar el filtrado del archivo hasta el final del inicio
			showbook()
		endif
	else
		if xFiltering05
			xFiltering05=.f.
			xFilterSet05="(estado=estado)"
			if Console.bookslv.visible = .t.				// Al inicio solo es necesario configurar el filtro departamental
				filterbook()								// No realizar el filtrado del archivo hasta el final del inicio
				showbook()
			endif
		endif
	endif
return

